/* Autogenerated with kurento-module-creator */

#ifndef __CRYPTO_SUITE_HPP__
#define __CRYPTO_SUITE_HPP__

#include <json/json.h>
#include <jsonrpc/JsonRpcException.hpp>
#include <memory>


namespace kurento
{
class CryptoSuite;
} /* kurento */

namespace kurento
{
class JsonSerializer;
void Serialize (std::shared_ptr<kurento::CryptoSuite> &object, JsonSerializer &s);
} /* kurento */

namespace kurento
{

class CryptoSuite
{

public:

  typedef enum {
    AES_128_CM_HMAC_SHA1_32,
    AES_128_CM_HMAC_SHA1_80,
    AES_256_CM_HMAC_SHA1_32,
    AES_256_CM_HMAC_SHA1_80
  } type;

  CryptoSuite (const std::string &value) {
    enumValue = getValueFromString (value);
  };

  CryptoSuite (type value) {
    this->enumValue = value;
  }

  type getValue () {
    return enumValue;
  };

  std::string getString () {

    if (enumValue ==  AES_128_CM_HMAC_SHA1_32) {
      return "AES_128_CM_HMAC_SHA1_32";
    }

    if (enumValue ==  AES_128_CM_HMAC_SHA1_80) {
      return "AES_128_CM_HMAC_SHA1_80";
    }

    if (enumValue ==  AES_256_CM_HMAC_SHA1_32) {
      return "AES_256_CM_HMAC_SHA1_32";
    }

    if (enumValue ==  AES_256_CM_HMAC_SHA1_80) {
      return "AES_256_CM_HMAC_SHA1_80";
    }

    return "";
  }

  void Serialize (JsonSerializer &s);

  CryptoSuite() = default;

private:

  static type getValueFromString (const std::string &value);

  type enumValue;

  friend void kurento::Serialize (std::shared_ptr<kurento::CryptoSuite> &object, JsonSerializer &s);

};

} /* kurento */

#endif /*  __CRYPTO_SUITE_HPP__ */
